# Fields Changes

## 0.8.11

- Added a `Bit16Editor`.

## 0.8.10

- Added styling for `optgroup` to the `ObjectEditor`.

## 0.8.9

- Changed the superclass of `ObjectEditor` to `EditorView<Object>`.

## 0.8.8

- Added the `check` method to `Range` and fixed a bug in the logic.

## 0.8.7

- Added a range check to the `NumberEditor` when a `Range` annotation is used.

## 0.8.6

- Added the `refreshOptions` method to `SelectEditor` so that a subclass may
override this method to build a custom list of options if desired.

## 0.8.5

- Added an optional `getValues` function to the `Values` annotation to provide a 
mechanism for supplying dynamic values to a `SelectEditor`.

## 0.8.4

- Fixed a bug when refreshing a field's children in the case where the shape of 
the field's value object changes.
- Renamed event streams using the `on*` naming convention.

## 0.8.3

- Updated toggle-button styling in the `ObjectEditor`.
- Removed a workaround for shadow `:host` styling in the `ObjectEditor`.
- Replaced calls to the deprecated `document.register` with calls to 
`document.registerElement`.

## 0.8.2

- Added types assignable to `TypedData` as default atomic types for field
reflection.

## 0.8.1

- Added types assignable to `Iterable` as default atomic types for field 
reflection.

## 0.8.0

- Decoupled the `fields.model` library from `dart:mirrors`.  This was done to
allow data classes to be annotated with field annotations without pulling in a 
transitive import of `dart:mirrors` (and thus leading to code bloat when 
compiled via `dart2js`).  Runtime applications and tools can now share such data
classes with only the tools depending on `dart:mirrors`.  Further, it is now
possible to design data using synthetic fields that may be tooled without 
`dart:mirrors` although this use case is still being worked on and the API is 
still very much subject to change.

## 0.7.2

- Added support for `num <-> double` in the default value transforms.
- Fixed some of the default parameters in the `new Field.synthetic` constructor.

## 0.7.1

- Fixed a bug in the default field editor where it would jump to the end of the
input element on each character input.
- Clear the field editors of the previous selection when selecting a new object
in the `ObjectEditor`.

## 0.7.0

- Renamed `selected` -> `selection` and `selectedChanged` -> `selectionChanged`
in the `ObjectEditor`.
- Added the top-level `atomicTypes` list to the `fields.model` library.  This
provides a means to register user-defined types as exceptions to the default
field reflection policy of this library.

## 0.6.5

- Temporarily removed usage of Shadow DOM in the `ObjectEditor` to fix styling 
issues in Chrome 33; The `:host` selector requires the `Enable experimental Web 
Platform features` in `chrome://flags` which no end-user actually sets.

## 0.6.4

- Changed the default `BoolEditor` implementation to a new version that scales 
properly.

## 0.6.3

- Fixed an error in usage of the type parameter `T` in the factory constructors
for `Field` that was caught by the vm as of Dart SDK 1.2.0.dev_02_04.

## 0.6.2

- Added the `Field.synthetic` factory constructor.
- Swapped the order of the `declaredName` and `owner` parameters in the 
`Field.forGetter` and `Field.forVariable` factory constructors.

## 0.6.1

- Updated to `tags` version 0.5.1.

## 0.6.0

- Moved the default field editors into the `tags.model` library.
- Renamed several of the annotations to have simpler names, please consult the
documentation.

## 0.5.0

- Removed the `@RuntimeType` annotation that was a workaround for Dart issues 
6433 and 12022, which are both resolved as of Dart SDK 1.1.0.dev_05_06.
- Applied the `Themeable` mixin to `ObjectEditor`.
- The `new ObjectEditor` factory constructor now specifies a default value for
the optional parameter `resources`, rather than applying the most recently used
resources as before.

## 0.4.0

- Renamed `FieldEditor.render` -> `FieldEditor.refreshElement` and this method
is now called from the base `FieldEditor` constructor using `scheduleMicrotask`
so that concrete editors need not call it from their constructors.
- Removed the `FieldEditor.isValueReadOnly` getter and merged its logic into 
the `FieldEditor.isEnabled` getter; the default editors now check `isEnabled`.
- Moved the `fields.model` and `fields.view` libraries into the top-level `lib/`
directory to make them more accessible for direct package imports.

## 0.3.0

- Renamed `Field.name` -> `Field.declaredName` and `Field.displayName` -> 
`Field.name`.
- Renamed `FieldTransform` -> `ValueTransform` and `FieldTransformError` ->
`ValueTransformError`.
- Renamed the following annotations for consistency across field annotations:
  - `DisplayName` -> `UseName`
  - `FieldDescription` -> `UseDescription`
  - `ReadOnly` -> `UseReadOnly`
  - `UseFieldTransform` -> `UseValueTransform`
- Replaced the `fieldsTheme` with an optional parameter of type 
`ObjectEditorResources` in the `new ObjectEditor` factory constructor.  If the
resources are not specified the most recently used resources are reused.

## 0.2.3

- Revert the changes from 0.2.2 and instead prefer usage of the 
`UseFieldTransform` annotation for this use case.  The `SelectEditor` now honors
the declared `UseFieldTransform` for option values.

## 0.2.2

- Added support for an optional `renderer` function in the `UseValues` 
annotation; the `SelectEditor` now makes a distinction between each value and
its rendered presentation, using the `renderer` if declared.

## 0.2.1

- Removed an usage of `Type` literals in a switch statement that no longer 
compiles via `dart2js` as of SDK 1.0.2_r30821.

## 0.2.0

- Moved the `theme` from its own library to `fields.view`; the `fields.model`
library is now decoupled from the theme.
- Removed support for `FieldEditorResources` from `FieldEditor`; the styling of
field editor elements is best left delegated to component and application views.
- Replaced the top-level `canTransformField` and `transformField` functions 
with the static methods `FieldTransform.canTransform` and 
`FieldTransform.transform`.

## 0.1.5

- Changed the default `BoolEditor` element to a `<div>` (was a `<span>`).

## 0.1.4

- Updated for the Dart 1.0 release.
- Added the `FieldDescription` annotation and use it in the `BoolEditor` if it
is declared on the field being edited.

## 0.1.3

- Updated to Dart SDK 0.8.10_r29803.
- Added a generic type parameter `T` to `Field<T>` as a means to document the 
underlying type of a field.  The type `T` is asserted to be assignable from the 
reflected type of the underlying object in checked mode only.

## 0.1.2

- Optimization in `FieldListView` render.

## 0.1.1

- Updated to Dart SDK 0.8.7_r29341.

## 0.1.0

- Changed `ObjectEditor` from a subtype of `HasElement` to a subtype of 
`HtmlElement`.
- Added the `@RuntimeType` annotation as a workaround for Dart issues 6433 and
12022.  This will be removed as soon as those issues are resolved, but in the
meantime it provides a means to ship working code.

## 0.0.8

- Updated to Dart SDK 0.7.6_r28108.
- Added a `SelectEditor` and `UseValues` annotation.
- Changed the `Field` and `FieldEditor` `value` accessors from asynchronous
methods that return futures to synchronous getters and setters.  The 
implementation now uses synchronous mirrors (`InstanceMirror.getField` etc...) 
to close issue #3.  This makes the API easier to use for extending `FieldEditor`
with your own custom editors.  It is also very likely that the asynchronous
mirrors API will be removed from `dart:mirrors` in the near future.
- Added a `UseFieldTransform` annotation.
- Changed the `FieldTransform` class to a concrete class that can be directly
instantiated as `const` with given `transform` and optional `inverse` functions.

## 0.0.7

- Updated to Dart SDK 0.7.3_r27487.
- Renamed the asset directory from 'lib/res/' to 'lib/asset/' in preparation for 
`pub serve`; this will move up to a top-level directory 'asset/' once `pub` is
able to serve that to the dependency graph.
- Added `Field.forGetter` and `Field.forVariable` factory constructors; these
are experimental and designed to make it easier to use `FieldEditor` instances
outside of an `ObjectEditor`.  For example, other data entry widgets such as a
data grid might want to reuse these field editors.  This is subject to change.

## 0.0.6

- Update to `tags` version 0.1.9.

## 0.0.5

- Added support for proxy objects; the fields of the `selected` object are 
reflected based on its `runtimeType`, which proxy classes may override.
- Moved all of the libraries into `lib/src/` and export the entire public API
through the `lib/fields.dart` library.  This provides a single import statement
for applications that use this package.

## 0.0.4

- Cleaned up the `FieldEditor` and `Transform` registration interfaces.
- Gave more specific names to the `Resources` classes.
- Added the `bench` package to `dev_dependencies` to run the unit tests.
- Updated to Dart SDK 0.6.13_r25630.

## 0.0.3

- Updated to `tags` version `0.1.4`.
- Changed the image links in the README.md to absolute links as Pub does not
recognize Github relative links: https://github.com/dart-lang/py-gfm/issues/8

## 0.0.2

- More early work.

## 0.0.1

- Initial version.
